/*
 * Created on 17 fvr. 2004
 * 
 * General constants for pathfinding application
 *  
 */
package graph.weighted.weightedNodes;

/**
 * @author didier
 */
public interface PathFindingInterface {
    
	
	/*
	 * Path finding metabolic graphs
	 */
	public final int NUMBER_OF_MODE = 5; // number of available pathfinding modes
    public final int ANNOTATED_PATHWAYS = 4; // for generation of html suplementary materials
    public final int MODIFIED_WHEIGTHED_MODE = 3;// search in a modified wheighted graph 
    public final int EXCLUSION_MODE = 1; // search in the Excluded/filtered graph
    public final int RAW_MODE = 2;// search in the RAW graph
    public final int WHEIGTHED_MODE = 0;// search in a wheighted by compound connectivity graph 
    
    /*
     * time out default parameters
     */
    public final long TIMEOUT_DEFAULT = -2; // use the default values
    public final long NO_TIMEOUT= -1; // No timeout
    
    /*
     * pathfinding methods
     */
    public final int BACKTRACK_ONLY = 0; // use only backtrack
    public final int REA_ONLY = 1; // use only REA
    public final int BACKTRACK_REA = 2; // use first bactrack to detect if there is the number of solutions requested and then go to REA
    
    /*
     *how to handle the seeds array lists
    */
    public final int BY_PAIRS = 0;
    public final int ALL_AGAINST_ALL = 1;
    public final int GROUP_PF = 2;
    
    /*
     * diferent Text representation for ouput  
     */
    public String [] STRING_MODE = {"Weighted","Filtered","Raw graph","Weighted graph with modified Weight(for internal testing)","Annotated pathway","Unknown mode !"};
    public String [] SHORT_STRING_MODE = {"W","E","R","MW","A","U"};
    /*
     * graphviz parameters
     */
    String [] graphvizformats = {"dot","png","ps2","svg"}; //output formats
    String [] graphvizmimeformats = {"text/plain","image/png","application/postscript","image/svg-xml"}; // mime formats
    String [] graphvizformatsnames = {"Dot","Png","Postscript2","Svg"}; // names
    String [] graphvizformatslinks = {"www.research.att.com/sw/tools/graphviz/","www.libpng.org/pub/png/","www.adobe.com","www.w3.org/Graphics/SVG/"}; // URL for descritpions
}
