package graph.weighted.weightedNodes;



/**
 * Class: Properties
 * Description: group of structures that can be shared between a reaction and his reverse.
 *
 * @author Fabian Couche
 * @version $Revision: 1.2 $
 */
public class Properties {

  /** Field id */
  private String _id;

  /** Field weight */
  private float _weight;

  /** Field m */
  private boolean _mark;

  /**
   * Properties Constructor
   * @param s the identifier of the element.
   * @param w the weight value.
   */
  public Properties (String s, float w) {

    setId (s);
    setWeight (w);
    mark (false);
  }

  /**
   * Sets the identifier.
   * @param id the identifier value.
   */
  public void setId (String id) {
    this._id = id;
  }

  /**
   * Returns the identifier.
   * @return String the identifier value.
   */
  public String getId () {
    return _id;
  }

  /**
   * Sets the weight.
   * @param weight the weight value.
   */
  public void setWeight (float weight) {
    this._weight = weight;
  }

  /**
   * Returns the weight.
   * @return the weight value.
   */
  public float getWeight () {
    return _weight;
  }

  /**
   * Changes the mark.
   * @param m the new value.
   */
  public void mark (boolean m) {
    this._mark = m;
  }

  /**
   * Returns the status.
   * @return the mark value.
   */
  public boolean isMarked () {
    return _mark;
  }
}


/*--- Formatted in North Style ---*/
